# Qui est-ce ?

Le `Qui est-ce ?` est un jeu pour apprendre à connaître les pseudos des 0As en premier lieu
mais aussi des autres promotions à l'école.

Ce projet utilise l'**API d'ARISE** et **AriseID Connect** (OIDC / OAuth2).

> Dans la mesure du possible, ce projet sera maintenu à jour pour refléter les bonnes pratiques
> de développement utilisant les standards ARISE (API & AIDC)

## Développement local

_Pour une présentation détaillée, lire la section [technologies](#technologies)_

Prérequis : [Node](https://nodejs.org/en/download)
Optionnel : [nvm (Node Version Manager)](https://github.com/nvm-sh/nvm#installing-and-updating)

### Installation

```shell
git clone git@git.iiens.net:Steel/qui-est-ce.git

cd qui-est-ce
cp .env.example .env

corepack enable # activation de pnpm

pnpm install
```

### Développement

```shell
pnpm dev
```

### Build

```shell
pnpm build
pnpm preview
```

## Technologies

Les pages utilisent le SSR (Server Side Rendering), ce qui implique d'avoir un serveur web pour
faire le pré-rendu des pages.

[NodeJS](https://nodejs.org) est un runtime JavaScript qui est ici utilisé comme serveur web.

[Typescript](https://www.typescriptlang.org/) est un langage de programmation fortement typé qui s'appuie sur JavaScript.

### Frontend

[Svelte](https://svelte.dev/) est un framework JavaScript pour créer des pages web réactives.

[Tailwind](https://tailwindcss.com/) est un framework CSS de classes utilitaires.

### Backend

[SvelteKit](https://kit.svelte.dev/) est le framework backend de préférence pour Svelte.

```graphql
mutation createToken {
  createToken(
    token: {
      id: "quiestce"
      description: "Qui est-ce | photos & pseudos"
      claims: [
        { claim: "users.id", access: READ }
        { claim: "users.nickname", access: READ }
        { claim: "users.photo", access: READ }
      ]
      allowedIps: ["0.0.0.0/0"]
    }
  ) {
    base64
  }
}
```
