import { sequence } from "@sveltejs/kit/hooks";
import { type Handle, redirect } from "@sveltejs/kit";
import { aidc } from "$lib/auth";

const authGuard: Handle = async ({ event, resolve }) => {
  if (!event.locals.user) {
    redirect(303, event.locals.authPaths.login);
  }
  return resolve(event);
};

export const handle = sequence(aidc.handler(), authGuard);
